#include <ESP8266WiFi.h>
#include <ESP8266HTTPClient.h>

// Defina suas credenciais de rede
const char* ssid = "florenca";
const char* password = "beneecuca";

WiFiClientSecure client;  // Utilizar WiFiClientSecure para HTTPS

void setup() {
  Serial.begin(115200);
  
  // Conecte-se à rede Wi-Fi
  WiFi.begin(ssid, password);
  
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.println("Conectando ao WiFi...");
  }
  
  Serial.println("Conectado ao WiFi");

  // Ignorar verificação de certificado (não recomendado para produção)
  client.setInsecure();
}

void loop() {
  if (WiFi.status() == WL_CONNECTED) { // Verifica se está conectado ao WiFi
    HTTPClient http;
    String serverUrl = "https://davidpezzin.com.br/horaedata.php"; // Utilize HTTPS

    http.begin(client, serverUrl); // Inicia a conexão HTTPS
    http.setFollowRedirects(HTTPC_STRICT_FOLLOW_REDIRECTS); // Seguir redirecionamentos automaticamente

    int httpCode = http.GET();
    
    if (httpCode > 0) { // Verifica se a requisição foi bem-sucedida
      if (httpCode == HTTP_CODE_OK) {
        String payload = http.getString();
        Serial.println("Data e Hora do servidor:");
        Serial.println(payload);
      } else {
        Serial.printf("Erro na resposta HTTP: %d\n", httpCode);
      }
    } else {
      Serial.printf("Erro na requisição HTTP: %s\n", http.errorToString(httpCode).c_str());
    }

    http.end(); // Encerra a conexão
  } else {
    Serial.println("Desconectado do WiFi, tentando reconectar...");
    WiFi.begin(ssid, password);
    while (WiFi.status() != WL_CONNECTED) {
      delay(1000);
      Serial.println("Conectando ao WiFi...");
    }
  }

  delay(59000); // Delay de 1 minuto para evitar requisições frequentes
}
